VirtualBox

source: vbox/trunk/configure@ 14926

Last change on this file since 14926 was 14926, checked in by vboxsync, 16 years ago

configure: TODO

  • Property svn:eol-style set to LF
  • Property svn:executable set to *
File size: 54.0 KB
Line 
1#!/bin/sh
2# The purpose of this script is to check for all external tools, headers, and
3# libraries VBox OSE depends on.
4
5#
6# Copyright (C) 2006-2007 Sun Microsystems, Inc.
7#
8# This file is part of VirtualBox Open Source Edition (OSE), as
9# available from http://www.virtualbox.org. This file is free software;
10# you can redistribute it and/or modify it under the terms of the GNU
11# General Public License as published by the Free Software Foundation,
12# in version 2 as it comes in the "COPYING" file of the VirtualBox OSE
13# distribution. VirtualBox OSE is distributed in the hope that it will
14# be useful, but WITHOUT ANY WARRANTY of any kind.
15#
16
17LC_ALL=C
18export LC_ALL
19
20# append some extra paths
21PATH="$PATH:/opt/gnome/bin"
22# Solaris (order of paths important for tr, echo, grep, sed to work)
23PATH="/usr/xpg4/bin:/usr/ucb:$PATH:/usr/local/bin:/usr/sfw/bin:/usr/ccs/bin"
24ORGPATH=$PATH
25
26# Wrapper for ancient /usr/bin/which on darwin that always returns 0
27which_wrapper()
28{
29 if [ -z "$have_ancient_which" ]; then
30 if which /bin/___cErTaINly_a_nOn_eXisTing_fIle___ 2> /dev/null > /dev/null; then
31 have_ancient_which="yes"
32 else
33 have_ancient_which="no"
34 fi
35 fi
36 if [ "$have_ancient_which" = "yes" ]; then
37 retval=`which $* 2>/dev/null`
38 echo "$retval"
39 test -n "$retval" -a -x "$retval"
40 unset retval
41 else
42 which $* 2> /dev/null
43 fi
44}
45
46
47#
48# Defaults
49#
50OSE=1
51ODIR="`pwd`/"
52SETUP_WINE=
53TARGET_MACHINE=""
54TARGET_CPU=""
55WITH_XPCOM=1
56WITH_PYTHON=1
57WITH_LIBIDL=1
58WITH_QT3=1
59WITH_QT4=1
60WITH_SDL=1
61WITH_SDL_TTF=1
62WITH_X11=1
63WITH_ALSA=1
64WITH_PULSE=1
65WITH_LIBHAL=1
66WITH_KMODS=1
67WITH_HARDENING=1
68CC="gcc"
69CC_COMPAT=""
70CC32=""
71CC64=""
72CXX="g++"
73CXX32=""
74CXX64=""
75BCC="bcc"
76YASM="yasm"
77IASL="iasl"
78AS86="as86"
79XSLTPROC="xsltproc"
80GENISOIMAGE="genisoimage"
81MKISOFS="mkisofs"
82BUILD_LIBXML2=
83BUILD_LIBXSLT=
84LIBCRYPTO="-lcrypto"
85LIBPTHREAD="-lpthread"
86LIBX11="-L/usr/X11R6/lib -L/usr/X11R6/lib64 -L/usr/local/lib -lXext -lX11"
87INCX11="/usr/local/include"
88LIBXCURSOR="-lXcursor"
89INCZ=""
90LIBZ="-lz"
91INCPNG=""
92LIBPNG="-lpng"
93PKGCONFIG="`which_wrapper pkg-config`"
94if [ -n $PKGCONFIG ]; then
95 FLAGSHAL="`$PKGCONFIG hal --cflags 2>/dev/null`"
96 LIBDIRHAL="`$PKGCONFIG hal --libs-only-L 2>/dev/null`"
97 LIBHAL="`$PKGCONFIG hal --libs-only-l 2>/dev/null`"
98fi
99PYTHONDIR="/usr /usr/local"
100QT3DIR="/usr/qt/3 /usr/lib/qt3 /usr/lib/qt-3.3 /usr/share/qt3"
101QT3DIR="$QT3DIR /usr/lib64/qt-3.3 /usr/X11R6 /usr/lib/qt"
102QT4DIR="/usr/lib/qt4 /usr/share/qt4 /usr/lib64/qt4 /usr"
103QT4DIR_PKGCONFIG=1
104QT4UIC3DIR="/usr/bin"
105KBUILDDIR="`cd \`dirname $0\`; pwd`/kBuild"
106DEVDIR="`cd \`dirname $0\`; pwd`/tools"
107if [ -d "/lib/modules/`uname -r`/build" ]; then
108 LINUX="/lib/modules/`uname -r`/build"
109else
110 LINUX="/usr/src/linux"
111fi
112KCHMVIEWER="kchmviewer"
113LOG="configure.log"
114CNF="AutoConfig.kmk"
115ENV="env.sh"
116BUILD_TYPE="release"
117# the restricting tool is ar (mri mode).
118INVALID_CHARS="[^A-Za-z0-9/\\$:._-]"
119
120if (cd `dirname $0`; pwd)|grep -q "$INVALID_CHARS"; then
121 echo "Error: VBox base path contains invalid characters!"
122 exit 1
123fi
124
125# darwin /bin/sh has a builtin echo that doesn't grok -n. gotta love it.
126if [ "`uname`" = "Darwin" ]; then
127 ECHO_N="/bin/echo -n"
128else
129 ECHO_N="echo -n"
130fi
131
132
133cleanup()
134{
135 rm -f .tmp_src.cc .tmp_src.c .tmp_out .test_execute.log
136}
137
138fail()
139{
140 if [ -z "$nofatal" -o "x$1" != "x" ]; then
141 cleanup
142 rm -f $ENV
143 exit 1
144 fi
145}
146
147log()
148{
149 echo "$1"
150 echo "$1" >> $LOG
151}
152
153log_success()
154{
155 if [ -n "$1" ]; then $ECHO_N "$1, "; fi
156 echo "OK."
157 echo "$1" >> $LOG
158 echo >> $LOG
159 echo >> $LOG
160}
161
162log_failure()
163{
164 echo
165 echo " ** $1!"
166 echo "** $1!" >> $LOG
167 echo >> $LOG
168}
169
170cnf_append()
171{
172 printf "%-30s := %s\n" "$1" "$2" >> $CNF
173}
174
175strip_l()
176{
177 echo "$1"|$KBUILD_SED 's|-l\([^ ]\+\)|\1|g; s|^-[^l][^ ]*||g; s| -[^l][^ ]*||g; s|^ ||; s| *$||g'
178}
179
180strip_L()
181{
182 echo "$1"|$KBUILD_SED 's|-L\([^ ]\+\)|\1|g; s|^-[^L][^ ]*||g; s| -[^L][^ ]*||g; s|^ ||; s| *$||g'
183}
184
185strip_I()
186{
187 echo "$1"|$KBUILD_SED 's|-I\([^ ]\+\)|\1|g; s|^-[^I][^ ]*||g; s| -[^I][^ ]*||g; s|^ ||; s| *$||g'
188}
189
190prefix_I()
191{
192 echo "$1"|$KBUILD_SED 's|^\/|-I/|g; s| \/| -I/|g'
193}
194
195check_avail()
196{
197 if [ -z "$1" ]; then
198 log_failure "$2 is empty"
199 fail $3
200 return 1
201 elif which_wrapper $1 > /dev/null; then
202 return 0
203 else
204 log_failure "$1 (variable $2) not found"
205 fail $3
206 return 1
207 fi
208}
209
210
211# Prepare a test
212test_header()
213{
214 echo "***** Checking $1 *****" >> $LOG
215 $ECHO_N "Checking for $1: "
216}
217
218
219# Compile a test
220test_compile()
221{
222 echo "compiling the following source file:" >> $LOG
223 cat .tmp_src.cc >> $LOG
224 echo "using the following command line:" >> $LOG
225 echo "$CXX -O -Wall -o .tmp_out .tmp_src.cc \"$1\"" >> $LOG
226 $CXX -O -Wall -o .tmp_out .tmp_src.cc $1 >> $LOG 2>&1
227 if [ $? -ne 0 ]; then
228 if [ -z "$4" ]; then
229 echo
230 echo " $2 not found at $1 or $3 headers not found"
231 echo " Check the file $LOG for detailed error information."
232 fail
233 else
234 echo "not found."
235 echo >> $LOG
236 echo >> $LOG
237 fi
238 return 1
239 fi
240 return 0
241}
242
243
244# Execute a compiled test binary
245test_execute()
246{
247 echo "executing the binary" >> $LOG
248 ./.tmp_out > .test_execute.log
249 rc=$?
250 cat .test_execute.log | tee -a $LOG
251 if [ $rc -ne 0 ]; then
252 fail $1
253 return 1
254 fi
255 echo >> $LOG
256 echo >> $LOG
257 return 0
258}
259
260
261# Execute a compiled test binary
262test_execute_path()
263{
264 echo "executing the binary (LD_LIBRARY_PATH=$1)" >> $LOG
265 LD_LIBRARY_PATH=$1 ./.tmp_out > .test_execute.log
266 rc=$?
267 cat .test_execute.log | tee -a $LOG
268 if [ $rc -ne 0 ]; then
269 fail
270 return 1
271 fi
272 echo >> $LOG
273 echo >> $LOG
274 return 0
275}
276
277
278#
279# Check for OS, MACHINE, CPU
280#
281check_environment()
282{
283 test_header environment
284 OS=`uname -s | sed -e 's/GNU\/Linux/Linux/g' | tr [:upper:] [:lower:]`
285 case "$OS" in
286 linux)
287 ;;
288 darwin)
289 ;;
290 freebsd)
291 ;;
292 sunos)
293 OS='solaris'
294 ;;
295 *)
296 log_failure "Cannot determine OS"
297 exit 1
298 ;;
299 esac
300 BUILD_CPU=`uname -m`
301 [ "$OS" = "solaris" ] && BUILD_CPU=`isainfo | cut -f 1 -d ' '`
302 case "$BUILD_CPU" in
303 i[3456789]86|x86|i86pc)
304 BUILD_MACHINE='x86'
305 LIB='lib'
306 ;;
307 x86_64|amd64)
308 BUILD_MACHINE='amd64'
309 BUILD_CPU='k8'
310 if [ "$OS" != "solaris" ]; then
311 # on AMD64 systems, 64bit libs are usually located in /usr/lib64
312 # see http://www.pathname.com/fhs/pub/fhs-2.3.html#LIB64
313 LIB='lib64'
314 else
315 # Solaris doesn't seem to subscribe to fhs, libs are usually in
316 # a '64' subdirectory of the standard 'lib' dirs while some 64-bit
317 # alternative binaries can be found in 'amd64' subdirs of the 'bin'
318 # ones. So, in order to find the right stuff (esp. sdl-config) we'll
319 # have to make sure the */bin/amd64 dirs are searched before the */bin
320 # ones. (The sed has some sideeffects, but they shouldn't harm us...)
321 echo "64-bit Solaris detected, hacking the PATH" >> $LOG
322 echo "old PATH: $PATH" >> $LOG
323 PATH=`echo ":$PATH:" | sed -e 's,\(:[^:]*/bin\):,\1/amd64:\1:,g' \
324 -e 's/^:*//' -e 's/:*$//g' -e 's/::*/:/g' `
325 export PATH
326 echo "new PATH: $PATH" >> $LOG
327 LIB='lib/64'
328 fi
329 ;;
330 *)
331 log_failure "Cannot determine system"
332 exit 1
333 ;;
334 esac
335 [ -z "$TARGET_MACHINE" ] && TARGET_MACHINE=$BUILD_MACHINE
336 [ -z "$TARGET_CPU" ] && TARGET_CPU=$BUILD_CPU
337 DEVDIR_BIN="$DEVDIR/$OS.$BUILD_MACHINE/bin"
338 log_success "Determined build machine: $OS.$BUILD_MACHINE, target machine: $OS.$TARGET_MACHINE"
339
340 echo "export BUILD_PLATFORM=\"$OS\"" >> $ENV
341 echo "export BUILD_PLATFORM_ARCH=\"$BUILD_MACHINE\"" >> $ENV
342 echo "export BUILD_TARGET=\"$OS\"" >> $ENV
343 echo "export BUILD_TARGET_ARCH=\"$TARGET_MACHINE\"" >> $ENV
344 echo "export BUILD_TARGET_CPU=\"$TARGET_CPU\"" >> $ENV
345 echo "export BUILD_TYPE=\"$BUILD_TYPE\"" >> $ENV
346}
347
348#
349# Check for gcc with version >= 3.2.
350# We depend on a working gcc, if we fail terminate in every case.
351#
352check_gcc()
353{
354 test_header gcc
355 if [ -n "$CC_COMPAT" ]; then
356 if check_avail "$CC_COMPAT" CC_COMPAT really; then
357 cc_compat_ver=`$CC_COMPAT -dumpversion` 2>/dev/null
358 if [ $? -ne 0 ]; then
359 log_failure "cannot execute '$CC_COMPAT -dumpversion'"
360 fail really
361 fi
362 cc_compat_maj=`echo $cc_compat_ver|cut -d. -f1`
363 cc_compat_min=`echo $cc_compat_ver|cut -d. -f2`
364 if [ $cc_compat_maj -lt 3 \
365 -o \( $cc_compat_maj -eq 3 -a $cc_compat_min -lt 2 \) \
366 -o \( $cc_compat_maj -eq 4 -a $cc_compat_min -lt 1 \) \
367 -o \( $cc_compat_maj -eq 4 -a $cc_compat_min -gt 2 \) \
368 -o $cc_compat_maj -gt 4 ]; then
369 log ""
370 log " ** Version $cc_compat_ver of the compatibility gcc found. Expected gcc 3.x with x>1"
371 log " ** or gcc 4.x with 0<x<3"
372 fail really
373 fi
374 cnf_append "VBOX_RECOMPILER_OP_GCC" "$CC_COMPAT"
375 fi
376 fi
377 if check_avail "$CC" CC really; then
378 cc_ver=`$CC -dumpversion` 2>/dev/null
379 if [ $? -ne 0 ]; then
380 log_failure "cannot execute '$CC -dumpversion'"
381 fail really
382 fi
383 if check_avail "$CXX" CXX really; then
384 cxx_ver=`$CXX -dumpversion` 2>/dev/null
385 if [ $? -ne 0 ]; then
386 log_failure "cannot execute '$CXX -dumpversion'"
387 fail really
388 fi
389 cc_maj=`echo $cc_ver|cut -d. -f1`
390 cc_min=`echo $cc_ver|cut -d. -f2`
391 if [ "x$cc_ver" != "x$cxx_ver" ]; then
392 log_failure "gcc version $cc_ver does not match g++ version $cxx_ver"
393 fail really
394 elif [ $cc_maj -eq 4 -a $cc_min -eq 0 -a "OS" = "darwin" ]; then
395 log_success "found version $cc_ver"
396 elif [ $cc_maj -eq 4 -a $cc_min -eq 3 ]; then
397 if [ -z "$CC_COMPAT" ]; then
398 log ""
399 log " ** There are known problems with gcc version 4.3 when compiling the recompiler"
400 log " ** stuff. You need to specify a compatibility compiler with version < 4.3. Look"
401 log " ** for a package compat-gcc-34 on Fedora systems or something similar on other"
402 log " ** distributions and call configure with parameter --with-gcc-compat=gcc34."
403 fail really
404 fi
405 log_success "found version $cc_ver + compat version $cc_compat_ver"
406 # gcc-4.0 is allowed for Darwin only
407 elif [ $cc_maj -lt 3 \
408 -o \( $cc_maj -eq 3 -a $cc_min -lt 2 \) \
409 -o \( $cc_maj -eq 4 -a $cc_min -lt 1 -a "$OS" != "darwin" \) \
410 -o \( $cc_maj -eq 4 -a $cc_min -gt 3 \) \
411 -o $cc_maj -gt 4 ]; then
412 log_failure "gcc version $cc_ver found, expected gcc 3.x with x>1 or gcc 4.x with 0<x<4"
413 fail really
414 else
415 log_success "found version $cc_ver"
416 fi
417 if [ "$BUILD_MACHINE" = "amd64" ]; then
418 [ -z "$CC32" ] && CC32="$CC -m32"
419 [ -z "$CXX32" ] && CXX32="$CXX -m32"
420 else
421 [ -z "$CC32" ] && CC32="$CC"
422 [ -z "$CXX32" ] && CXX32="$CXX"
423 fi
424 if [ "$BUILD_MACHINE" = "x86" -a "$TARGET_MACHINE" = "amd64" ]; then
425 [ -z "$CC64" ] && CC64="$CC -m64"
426 [ -z "$CXX64" ] && CXX64="$CXX -m64"
427 fi
428 if [ "$CC" != "gcc" ]; then
429 cnf_append "TOOL_GCC3_CC" "$CC"
430 cnf_append "TOOL_GCC3_AS" "$CC"
431 cnf_append "TOOL_GCC3_LD" "$CC"
432 cnf_append "TOOL_GXX3_CC" "$CC"
433 cnf_append "TOOL_GXX3_AS" "$CC"
434 fi
435 if [ "$CXX" != "g++" ]; then
436 cnf_append "TOOL_GCC3_CXX" "$CXX"
437 cnf_append "TOOL_GXX3_CXX" "$CXX"
438 cnf_append "TOOL_GXX3_LD" "$CXX"
439 fi
440 if [ "$CC32" != "gcc -m32" ]; then
441 cnf_append "TOOL_GCC32_CC" "$CC32"
442 cnf_append "TOOL_GCC32_AS" "$CC32"
443 cnf_append "TOOL_GCC32_LD" "$CC32"
444 cnf_append "TOOL_GXX32_CC" "$CC32"
445 cnf_append "TOOL_GXX32_AS" "$CC32"
446 fi
447 if [ "$CXX32" != "g++ -m32" ]; then
448 cnf_append "TOOL_GCC32_CXX" "$CXX32"
449 cnf_append "TOOL_GXX32_CXX" "$CXX32"
450 cnf_append "TOOL_GXX32_LD" "$CXX32"
451 fi
452 # this isn't not necessary, there is not such tool.
453 if [ -n "$CC64" ]; then
454 cnf_append "TOOL_GCC64_CC" "$CC64"
455 cnf_append "TOOL_GCC64_AS" "$CC64"
456 cnf_append "TOOL_GCC64_LD" "$CC64"
457 cnf_append "TOOL_GXX64_CC" "$CC64"
458 cnf_append "TOOL_GXX64_AS" "$CC64"
459 fi
460 if [ -n "$CXX64" ]; then
461 cnf_append "TOOL_GCC64_CXX" "$CXX64"
462 cnf_append "TOOL_GXX64_CXX" "$CXX64"
463 cnf_append "TOOL_GXX64_LD" "$CXX64"
464 fi
465 # Solaris sports a 32-bit gcc/g++.
466 if [ "$OS" = "solaris" -a "$BUILD_MACHINE" = "amd64" ]; then
467 [ "$CC" = "gcc" ] && CC="gcc -m64"
468 [ "$CXX" = "g++" ] && CXX="g++ -m64"
469 fi
470 fi
471 fi
472}
473
474
475#
476# Check for the bcc compiler, needed for compiling the BIOS
477#
478check_bcc()
479{
480 test_header bcc
481 if check_avail "$BCC" BCC; then
482 bcc_ver=`$BCC -v 2>&1|grep version|sed 's+^bcc: version \(.*\)+\1+'`
483 if [ $? -ne 0 ]; then
484 log_failure "not found"
485 fail
486 else
487 echo "compiling the following source file:" >> $LOG
488 cat > .tmp_src.c << EOF
489int foo(a)
490 int a;
491{
492 return 0;
493}
494EOF
495 cat .tmp_src.c >> $LOG
496 bcc_path=`which_wrapper $BCC`
497 bcc_dir="`dirname $bcc_path`/"
498 echo "using the following command line:" >> $LOG
499 echo "$BCC -B $bcc_dir -C-c -3 -S -o .tmp_out .tmp_src.c" >> $LOG
500 $BCC -B $bcc_dir -C-c -3 -S -o .tmp_out .tmp_src.c >> $LOG 2>&1
501 if [ $? -ne 0 ]; then
502 log_failure "not found"
503 fail
504 else
505 log_success "found version $bcc_ver"
506 cnf_append "VBOX_BCC" "$bcc_path -B $bcc_dir"
507 fi
508 unset bcc_path
509 unset bcc_dir
510 fi
511 fi
512}
513
514
515#
516# Check for the as86 assembler, needed for compiling the BIOS
517#
518check_as86()
519{
520 test_header as86
521 if check_avail "$AS86" AS86; then
522 as86_ver=`$AS86 -v 2>&1|grep version|sed 's+^as86 version: \(.*\)+\1+'`
523 if [ $? -ne 0 ]; then
524 log_failure "not found"
525 fail
526 else
527 log_success "found version $as86_ver"
528 cnf_append "VBOX_AS86" "`which_wrapper $AS86`"
529 fi
530 fi
531}
532
533
534#
535# Check for yasm, needed to compile assembler files
536#
537check_yasm()
538{
539 test_header yasm
540 if check_avail "$YASM" YASM; then
541 yasm_ver=`$YASM --version|grep "^yasm"|sed 's+^yasm \(.*\)+\1+'`
542 if [ $? -ne 0 ]; then
543 log_failure "not found"
544 fail
545 else
546 yasm_maj=`echo $yasm_ver|cut -d. -f1`
547 yasm_min=`echo $yasm_ver|cut -d. -f2`
548 yasm_rev=`echo $yasm_ver|cut -d. -f3`
549 yasm_ver_mul=`expr $yasm_maj \* 10000 + $yasm_min \* 100 + $yasm_rev`
550 if [ $yasm_ver_mul -lt 501 ]; then
551 log_failure "found version $yasm_ver, expected at least 0.5.1"
552 fail
553 else
554 log_success "found version $yasm_ver"
555 fi
556 fi
557 fi
558}
559
560
561#
562# Check for the iasl ACPI compiler, needed to compile vbox.dsl
563#
564check_iasl()
565{
566 test_header iasl
567 if check_avail "$IASL" IASL; then
568 iasl_ver=`$IASL|grep version|sed 's+^ASL.*version \([0-9]*\).*+\1+'`
569 if [ $? -ne 0 ]; then
570 log_failure "not found"
571 fail
572 else
573 log_success "found version $iasl_ver"
574 cnf_append "VBOX_IASLCMD" "`which_wrapper $IASL`"
575 fi
576 fi
577}
578
579
580#
581# Check for xsltproc, needed by Main
582#
583check_xsltproc()
584{
585 test_header xslt
586 if check_avail "$XSLTPROC" XSLTPROC; then
587 xsltproc_ver=`$XSLTPROC --version`
588 if [ $? -ne 0 ]; then
589 log_failure "not found"
590 fail
591 else
592 log_success "found"
593 cnf_append "VBOX_XSLTPROC" "`which_wrapper $XSLTPROC`"
594 fi
595 fi
596}
597
598
599#
600# Check for mkisofs, needed to build the CDROM image containing the additions
601#
602check_mkisofs()
603{
604 test_header mkisofs
605 if which_wrapper $GENISOIMAGE > /dev/null; then
606 mkisofs_ver=`$GENISOIMAGE --version`
607 if [ $? -ne 0 ]; then
608 log_failure "not found"
609 fail
610 else
611 log_success "found $mkisofs_ver"
612 cnf_append "VBOX_MKISOFS" "`which_wrapper $GENISOIMAGE`"
613 fi
614 elif check_avail "$MKISOFS" MKISOFS; then
615 mkisofs_ver=`$MKISOFS --version`
616 if [ $? -ne 0 ]; then
617 log_failure "not found"
618 fail
619 else
620 log_success "found $mkisofs_ver"
621 cnf_append "VBOX_MKISOFS" "`which_wrapper $MKISOFS`"
622 fi
623 fi
624}
625
626
627#
628# Check for libxml2, needed by VBoxSettings
629# 2.6.24 is known to NOT work, 2.6.26 is known to work (there is no 2.6.25 release)
630#
631check_libxml2()
632{
633 if [ -z "$BUILD_LIBXML2" ]; then
634 test_header libxml2
635 if which_wrapper pkg-config > /dev/null; then
636 libxml2_ver=`pkg-config libxml-2.0 --modversion 2>> $LOG`
637 if [ $? -ne 0 ]; then
638 log_failure "not found"
639 fail
640 else
641 FLGXML2=`pkg-config libxml-2.0 --cflags`
642 INCXML2=`strip_I "$FLGXML2"`
643 LIBXML2=`pkg-config libxml-2.0 --libs`
644 cat > .tmp_src.cc << EOF
645#include <cstdio>
646#include <libxml/xmlversion.h>
647extern "C" int main(void)
648{
649 printf("found version %s", LIBXML_DOTTED_VERSION);
650#if LIBXML_VERSION >= 20626
651 printf(", OK.\n");
652 return 0;
653#else
654 printf(", expected version 2.6.26 or higher\n");
655 return 1;
656#endif
657}
658EOF
659 [ -n "$INCXML2" ] && I_INCXML2=`prefix_I "$INCXML2"`
660 if test_compile "$LIBXML2 $LIBPTHREAD $I_INCXML2" xml2 xml2; then
661 if test_execute; then
662 cnf_append "SDK_VBOX_LIBXML2_INCS" "$INCXML2"
663 cnf_append "SDK_VBOX_LIBXML2_LIBS" "`strip_l "$LIBXML2"`"
664 fi
665 fi
666 fi
667 elif which_wrapper xml2-config; then
668 libxml2_ver=`xml2-config --version`
669 if [ $? -ne 0 ]; then
670 log_failure "not found"
671 fail
672 else
673 log_success "found version $libxml2_ver"
674 FLGXML2=`xml2-config --cflags`
675 INCXML2=`strip_I "$FLGXML2"`
676 LIBXML2=`xml2-config --libs`
677 cat > .tmp_src.cc << EOF
678#include <cstdio>
679#include <libxml/xmlversion.h>
680extern "C" int main(void)
681{
682 printf("found version %s", LIBXML_DOTTED_VERSION);
683#if LIBXML_VERSION >= 20626
684 printf(", OK.\n");
685 return 0;
686#else
687 printf(", expected version 2.6.26 or higher\n");
688 return 1;
689#endif
690}
691EOF
692 [ -n "$INCXML2" ] && I_INCXML2=`prefix_I "$INCXML2"`
693 if test_compile "$LIBXML2 $LIBPTHREAD $I_INCXML2" xml2 xml2; then
694 if test_execute; then
695 cnf_append "SDK_VBOX_LIBXML2_INCS" "$INCXML2"
696 cnf_append "SDK_VBOX_LIBXML2_LIBS" "`strip_l "$LIBXML2"`"
697 fi
698 fi
699 fi
700 else
701 log_failure "neither pkg-config nor xml2-config found"
702 fail
703 fi
704 fi
705}
706
707
708#
709# Check for libxslt, needed by VBoxSettings. For now we depend on 1.1.17.
710# This library is available on Ubuntu Edgy which fulfils the minimal libxml2
711# requirement (2.6.26).
712#
713check_libxslt()
714{
715 if [ -z "$BUILD_LIBXSLT" ]; then
716 test_header libxslt
717 if which_wrapper pkg-config > /dev/null; then
718 libxslt_ver=`pkg-config libxslt --modversion 2>> $LOG`
719 if [ $? -ne 0 ]; then
720 log_failure "not found"
721 fail
722 else
723 FLGXSLT=`pkg-config libxslt --cflags`
724 INCXSLT=`strip_I "$FLGXSLT"`
725 LIBXSLT=`pkg-config libxslt --libs`
726 cat > .tmp_src.cc << EOF
727#include <cstdio>
728#include <libxslt/xsltconfig.h>
729extern "C" int main(void)
730{
731 printf("found version %s", LIBXSLT_DOTTED_VERSION);
732#if LIBXSLT_VERSION >= 10117
733 printf(", OK.\n");
734 return 0;
735#else
736 printf(", expected version 1.1.17 or higher\n");
737 return 1;
738#endif
739}
740EOF
741 [ -n "$INCXSLT" ] && I_INCXSLT=`prefix_I "$INCXSLT"`
742 if test_compile "$LIBXSLT $LIBPTHREAD $I_INCXSLT" xslt xslt; then
743 if test_execute; then
744 cnf_append "SDK_VBOX_LIBXSLT_INCS" "$INCXSLT"
745 cnf_append "SDK_VBOX_LIBXSLT_LIBS" "`strip_l "$LIBXSLT"`"
746 fi
747 fi
748 fi
749 elif which_wrapper xslt-config; then
750 libxslt_ver=`xslt-config --version`
751 if [ $? -ne 0 ]; then
752 log_failure "not found"
753 fail
754 else
755 log_success "found version $libxslt_ver"
756 FLGXSLT=`xslt-config --cflags`
757 INCXSLT=`strip_I "$FLGXSLT"`
758 LIBXSLT=`xslt-config --libs`
759 cat > .tmp_src.cc << EOF
760#include <cstdio>
761#include <libxslt/xsltconfig.h>
762extern "C" int main(void)
763{
764 printf("found version %s", LIBXSLT_DOTTED_VERSION);
765#if LIBXSLT_VERSION >= 10117
766 printf(", OK.\n");
767 return 0;
768#else
769 printf(", expected version 1.1.17 or higher\n");
770 return 1;
771#endif
772}
773EOF
774 [ -n "$INCXSLT" ] && I_INCXSLT=`prefix_I "$INCXSLT"`
775 if test_compile "$LIBXSLT $LIBPTHREAD $I_INCXSLT" xslt xslt; then
776 if test_execute; then
777 cnf_append "SDK_VBOX_LIBXSLT_INCS" "$INCXSLT"
778 cnf_append "SDK_VBOX_LIBXSLT_LIBS" "`strip_l "$LIBXSLT"`"
779 fi
780 fi
781 fi
782 else
783 log_failure "neither pkg-config nor xslt-config found"
784 fail
785 fi
786 fi
787}
788
789
790#
791# Check for libIDL, needed by xpcom
792#
793check_libidl()
794{
795 test_header libIDL
796
797 if which_wrapper libIDL-config-2 > /dev/null; then
798 libidl_ver=`libIDL-config-2 --version`
799 if [ $? -ne 0 ]; then
800 log_failure "not found"
801 fail
802 else
803 log_success "found version $libidl_ver"
804 cnf_append "VBOX_LIBIDL_CONFIG" \
805 "PKG_CONFIG_PATH=`libIDL-config-2 --prefix`/$LIB/pkgconfig `which_wrapper libIDL-config-2`"
806 fi
807 elif check_avail "libIDL-config" libIDL-config; then
808 libidl_ver=`libIDL-config --version`
809 if [ $? -ne 0 ]; then
810 log_failure "not found"
811 fail
812 else
813 log_success "found version $libidl_ver"
814 cnf_append "VBOX_LIBIDL_CONFIG" "`which_wrapper libIDL-config`"
815 fi
816 fi
817}
818
819
820#
821# Check for openssl, needed for RDP
822#
823check_ssl()
824{
825 test_header ssl
826 cat > .tmp_src.cc << EOF
827#include <cstdio>
828#include <openssl/opensslv.h>
829extern "C" int main(void)
830{
831 printf("found version %s", OPENSSL_VERSION_TEXT);
832#if OPENSSL_VERSION_NUMBER >= 0x0090700
833 printf(", OK.\n");
834 return 0;
835#else
836 printf(", expected version 0.9.7 or higher\n");
837 return 1;
838#endif
839}
840EOF
841 if test_compile $LIBCRYPTO libcrypto openssl; then
842 if test_execute nofatal; then
843 cnf_append "SDK_VBOX_OPENSSL_INCS" ""
844 cnf_append "SDK_VBOX_OPENSSL_LIBS" "`strip_l "$LIBCRYPTO"`"
845 fi
846 fi
847}
848
849
850#
851# Check for pthread, needed by VBoxSVC, frontends, ...
852#
853check_pthread()
854{
855 test_header pthread
856 cat > .tmp_src.cc << EOF
857#include <cstdio>
858#include <pthread.h>
859extern "C" int main(void)
860{
861 pthread_mutex_t mutex;
862 if (pthread_mutex_init(&mutex, NULL)) {
863 printf("pthread_mutex_init() failed\n");
864 return 1;
865 }
866 if (pthread_mutex_lock(&mutex)) {
867 printf("pthread_mutex_lock() failed\n");
868 return 1;
869 }
870 if (pthread_mutex_unlock(&mutex)) {
871 printf("pthread_mutex_unlock() failed\n");
872 return 1;
873 }
874 printf("found, OK.\n");
875}
876EOF
877 if test_compile $LIBPTHREAD pthread pthread; then
878 if test_execute; then
879 cnf_append "LIB_PTHREAD" "`strip_l "$LIBPTHREAD"`"
880 fi
881 fi
882}
883
884
885#
886# Check for zlib, needed by VBoxSVC, Runtime, ...
887#
888check_z()
889{
890 test_header zlib
891 cat > .tmp_src.cc << EOF
892#include <cstdio>
893#include <zlib.h>
894extern "C" int main(void)
895{
896 printf("found version %s", ZLIB_VERSION);
897#if ZLIB_VERNUM >= 0x1210
898 printf(", OK.\n");
899 return 0;
900#else
901 printf(", expected version 1.2.1 or higher\n");
902 return 1;
903#endif
904}
905EOF
906 [ -n "$INCZ" ] && I_INCZ=`prefix_I "$INCZ"`
907 if test_compile "$LIBZ $I_INCZ" zlib zlib; then
908 if test_execute; then
909 cnf_append "SDK_VBOX_ZLIB_LIBS" "`strip_l "$LIBZ"`"
910 cnf_append "SDK_VBOX_ZLIB_INCS" "$INCZ"
911 fi
912 fi
913}
914
915
916#
917# Check for libpng, needed by kchmviewer
918#
919check_png()
920{
921 test_header libpng
922 cat > .tmp_src.cc << EOF
923#include <cstdio>
924#include <png.h>
925extern "C" int main(void)
926{
927 printf("found version %s", PNG_LIBPNG_VER_STRING);
928#if PNG_LIBPNG_VER >= 10205
929 printf(", OK.\n");
930 return 0;
931#else
932 printf(", expected version 1.2.5 or higher\n");
933 return 1;
934#endif
935}
936EOF
937 [ -n "$INCPNG" ] && I_INCPNG=`prefix_I "$INCPNG"`
938# if test_compile "$LIBPNG $I_INCPNG" libpng libpng nofatal; then
939 if test_compile "$LIBPNG $I_INCPNG" libpng libpng; then
940# if test_execute nofatal; then
941 if test_execute; then
942 cnf_append "SDK_VBOX_LIBPNG_LIBS" "`strip_l "$LIBPNG"`"
943 cnf_append "SDK_VBOX_LIBPNG_INCS" "$INCPNG"
944 fi
945 fi
946}
947
948
949#
950# Check for pam, needed by VRDPAuth
951# Version 79 was introduced in 9/2005, do we support older versions?
952# Debian/sarge uses 76
953# OpenSUSE comes with 0.99.xxx where they changed the versioning scheme.
954#
955check_pam()
956{
957 test_header pam
958 cat > .tmp_src.cc << EOF
959#include <cstdio>
960#include <security/pam_appl.h>
961extern "C" int main(void)
962{
963 printf("found version %d", __LIBPAM_VERSION);
964 if (__LIBPAM_VERSION >= 76)
965 {
966 printf(", OK.\n");
967 return 0;
968 }
969 else
970 {
971 printf(", expected version 76 or higher\n");
972 return 1;
973 }
974}
975EOF
976 if test_compile "-lpam" pam pam nofatal; then
977 if test_execute nofatal; then
978 return 0;
979 fi
980 fi
981 test_header linux_pam
982 cat > .tmp_src.cc << EOF
983#include <cstdio>
984#include <security/pam_appl.h>
985extern "C" int main(void)
986{
987 printf("found version %d.%d", __LINUX_PAM__, __LINUX_PAM_MINOR__);
988 if (__LINUX_PAM__ >= 1)
989 {
990 printf(", OK.\n");
991 return 0;
992 }
993 else
994 {
995 printf(", expected version 1.0 or higher\n");
996 return 1;
997 }
998}
999EOF
1000 if test_compile "-lpam" pam pam; then
1001 test_execute
1002 fi
1003}
1004
1005
1006#
1007# Check for the SDL library, needed by VBoxSDL and VirtualBox
1008# We depend at least on version 1.2.7
1009#
1010check_sdl()
1011{
1012 test_header SDL
1013 if [ "$OS" = "darwin" ]; then
1014 if [ -f "/System/Library/Frameworks/SDL.framework/SDL" ]; then
1015 PATH_SDK_LIBSDL="/System/Library/Framework/SDL.framework"
1016 elif [ -f "/Library/Frameworks/SDL.framework/SDL" ]; then
1017 PATH_SDK_LIBSDL="/Library/Frameworks/SDL.framework"
1018 fi
1019 if [ -n "$PATH_SDK_LIBSDL" ]; then
1020 foundsdl=1
1021 INCSDL="$PATH_SDK_LIBSDL/Headers"
1022 FLDSDL="-framework SDL"
1023 else
1024 log_failure "SDL framework not found"
1025 fail
1026 fi
1027 else
1028 if which_wrapper sdl-config > /dev/null; then
1029 FLGSDL=`sdl-config --cflags`
1030 INCSDL=`strip_I "$FLGSDL"`
1031 LIBSDL=`sdl-config --libs`
1032 LIBSDLMAIN="-lSDLmain"
1033 FLDSDL=
1034 foundsdl=1
1035 fi
1036 fi
1037 [ "$OS" = "linux" -o "$OS" = "darwin" -o "$OS" = "solaris" ] && LIBSDLMAIN=""
1038 if [ -n "$foundsdl" ]; then
1039 cat > .tmp_src.cc << EOF
1040#include <cstdio>
1041#include <SDL.h>
1042#include <SDL_main.h>
1043#undef main
1044extern "C" int main(int argc, char** argv)
1045{
1046 printf("found version %d.%d.%d",
1047 SDL_MAJOR_VERSION, SDL_MINOR_VERSION, SDL_PATCHLEVEL);
1048#if SDL_VERSION_ATLEAST(1,2,7)
1049 printf(", OK.\n");
1050 return 0;
1051#else
1052 printf(", expected version 1.2.7 or higher\n");
1053 return 1;
1054#endif
1055}
1056EOF
1057 [ -n "$INCSDL" ] && I_INCSDL=`prefix_I "$INCSDL"`
1058 if test_compile "$LIBSDL $LIBSDLMAIN $I_INCSDL $FLDSDL" SDL SDL; then
1059 if test_execute; then
1060 cnf_append "LIB_SDK_LIBSDL_SDL" "`strip_l "$LIBSDL"`"
1061 cnf_append "SDK_LIBSDL_LIBPATH" "`strip_L "$LIBSDL"`"
1062 cnf_append "LIB_SDK_LIBSDL_SDLMAIN" "`strip_l "$LIBSDLMAIN"`"
1063 [ -n "$INCSDL" ] && cnf_append "SDK_LIBSDL_INCS" "$INCSDL"
1064 [ -n "$FLDSDL" ] && cnf_append "SDK_LIBSDL_LDFLAGS" "$FLDSDL"
1065 fi
1066 fi
1067 else
1068 log_failure "not found"
1069 fail
1070 fi
1071}
1072
1073
1074#
1075# Check for the SDL_ttf library, needed by VBoxSDL (secure label)
1076#
1077check_sdl_ttf()
1078{
1079 test_header SDL_ttf
1080 cat > .tmp_src.cc << EOF
1081#include <cstdio>
1082#include <SDL_ttf.h>
1083#ifndef SDL_TTF_MAJOR_VERSION
1084#define SDL_TTF_MAJOR_VERSION TTF_MAJOR_VERSION
1085#define SDL_TTF_MINOR_VERSION TTF_MINOR_VERSION
1086#define SDL_TTF_PATCHLEVEL TTF_PATCHLEVEL
1087#endif
1088extern "C" int main(void)
1089{
1090 printf("found version %d.%d.%d",
1091 SDL_TTF_MAJOR_VERSION, SDL_TTF_MINOR_VERSION, SDL_TTF_PATCHLEVEL);
1092#if 10000*SDL_TTF_MAJOR_VERSION + 100*SDL_TTF_MINOR_VERSION + SDL_TTF_PATCHLEVEL >= 20006
1093 printf(", OK.\n");
1094 return 0;
1095#else
1096 printf(", expected version 2.0.6 or higher\n");
1097 return 1;
1098#endif
1099}
1100EOF
1101 if test_compile "-lSDL_ttf $I_INCSDL" SDL_ttf SDL_ttf nofatal; then
1102 if ! test_execute nofatal; then
1103 cnf_append "VBOX_WITH_SECURELABEL" ""
1104 fi
1105 else
1106 cnf_append "VBOX_WITH_SECURELABEL" ""
1107 fi
1108}
1109
1110
1111#
1112# Check for libasound, needed by the ALSA audio backend
1113#
1114check_alsa()
1115{
1116 test_header ALSA
1117 cat > .tmp_src.cc << EOF
1118#include <cstdio>
1119#include <alsa/asoundlib.h>
1120extern "C" int main(void)
1121{
1122 printf("found version %d.%d.%d",
1123 SND_LIB_MAJOR, SND_LIB_MINOR, SND_LIB_SUBMINOR);
1124#if 10000*SND_LIB_MAJOR + 100*SND_LIB_MINOR + SND_LIB_SUBMINOR >= 10006
1125 printf(", OK.\n");
1126 return 0;
1127#else
1128 printf(", expected version 1.0.6 or higher\n");
1129 return 1;
1130#endif
1131}
1132EOF
1133 if test_compile "-lasound" asound asound; then
1134 test_execute
1135 fi
1136}
1137
1138
1139#
1140# Check for PulseAudio
1141#
1142check_pulse()
1143{
1144 test_header "PulseAudio"
1145 cat > .tmp_src.cc << EOF
1146#include <cstdio>
1147#include <pulse/version.h>
1148extern "C" int main(void)
1149{
1150 printf("found version %s API version %d", pa_get_headers_version(), PA_API_VERSION);
1151#if PA_API_VERSION >= 9
1152 printf(", OK.\n");
1153 return 0;
1154#else
1155 printf(", expected version 0.9.0 (API version 9) or higher\n");
1156 return 1;
1157#endif
1158}
1159EOF
1160 if test_compile "-lpulse" pulse pulse; then
1161 test_execute
1162 fi
1163}
1164
1165
1166#
1167# Check for libhal
1168#
1169check_libhal()
1170{
1171 test_header "libhal"
1172 cat > .tmp_src.cc << EOF
1173#include <libhal.h>
1174extern "C" int main(void)
1175{
1176 return 0;
1177}
1178EOF
1179 if [ -n $PKGCONFIG ] && test_compile "$FLAGSHAL $LIBDIRHAL $LIBHAL" libhal libhal; then
1180 log_success "found"
1181 fi
1182}
1183
1184
1185#
1186# Check for the Xcursor library, needed by VBoxSDL and VBoxBFE
1187#
1188check_xcursor()
1189{
1190 test_header Xcursor
1191 cat > .tmp_src.cc << EOF
1192#include <cstdio>
1193#include <X11/Xlib.h>
1194#include <X11/Xcursor/Xcursor.h>
1195extern "C" int main(void)
1196{
1197 XcursorImage *cursor = XcursorImageCreate (10, 10);
1198 XcursorImageDestroy(cursor);
1199 return 0;
1200}
1201EOF
1202 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1203 if test_compile "$LIBX11 $LIBXCURSOR $I_INCX11" Xcursor Xcursor; then
1204 log_success "found"
1205 cnf_append "VBOX_XCURSOR_LIBS" "`strip_l "$LIBXCURSOR"`"
1206 fi
1207}
1208
1209
1210#
1211# Check for the X libraries (Xext, X11)
1212#
1213check_x()
1214{
1215 test_header "X libraries"
1216 cat > .tmp_src.cc << EOF
1217#include <cstdio>
1218#include <X11/Xlib.h>
1219extern "C" int main(void)
1220{
1221 Display *dpy;
1222 int scrn_num;
1223 Screen *scrn;
1224 Window win;
1225
1226 dpy = XOpenDisplay(NULL);
1227 scrn_num = DefaultScreen(dpy);
1228 scrn = ScreenOfDisplay(dpy, scrn_num);
1229 win = XCreateWindow(dpy, RootWindowOfScreen(scrn), 0, 0, 100, 100,
1230 0, 16, InputOutput, CopyFromParent, 0, NULL);
1231 XDestroyWindow(dpy, win);
1232}
1233EOF
1234 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1235 if test_compile "$LIBX11 $I_INCX11" Xlibs Xlibs; then
1236 log_success "found"
1237 fi
1238}
1239
1240
1241#
1242# Check for the Qt3 library, needed by VirtualBox
1243#
1244check_qt3()
1245{
1246 test_header Qt3
1247 cat > .tmp_src.cc << EOF
1248#include <cstdio>
1249#include <qglobal.h>
1250extern "C" int main(void)
1251{
1252 printf("found version %s", QT_VERSION_STR);
1253#if QT_VERSION >= 0x030305
1254 printf(", OK.\n");
1255 return 0;
1256#elif QT_VERSION >= 0x030300
1257 printf("\n ** WARNING: QT < 3.3.5 has known problems!\n");
1258#else
1259 printf(", expected version 3.3.0 or higher\n");
1260 return 1;
1261#endif
1262}
1263EOF
1264 found_qt=0
1265 libs="lib"
1266 [ "$LIB" = "lib64" ] && libs="$libs lib64"
1267 for q in $QT3DIR; do
1268 for l in $libs; do
1269 echo "compiling the following source file:" >> $LOG
1270 cat .tmp_src.cc >> $LOG
1271 echo "using the following command line:" >> $LOG
1272 echo "$CXX -O -Wall -o .tmp_out .tmp_src.cc -I$q/include -L$q/$l -lqt-mt $LIBPTHREAD" >> $LOG
1273 $CXX -O -Wall -o .tmp_out .tmp_src.cc -I$q/include -L$q/$l -lqt-mt $LIBPTHREAD >> $LOG 2>&1
1274 if [ $? -eq 0 ]; then
1275 if test_execute; then
1276 cnf_append "PATH_SDK_QT3" "`cd $q ; pwd`"
1277 found_qt=1
1278 break
1279 fi
1280 fi
1281 done
1282 if [ $found_qt -eq 1 ]; then
1283 break
1284 fi
1285 done
1286 if [ $found_qt -ne 1 ]; then
1287 echo
1288 echo " Qt3 not found at \"$QT3DIR\" or Qt3 headers not found"
1289 echo " Check the file $LOG for detailed error information."
1290 fail
1291 return 1
1292 fi
1293 test_header "Qt3 devtools"
1294 if check_avail "$q/bin/moc" QT3DIR/bin; then
1295 moc_ver=`$q/bin/moc 2>&1 -v|sed 's+^.*(Qt \(.*\))+\1+'`
1296 if [ $? -ne 0 ]; then
1297 log_failure "not found"
1298 fail
1299 else
1300 log_success "found version $moc_ver"
1301 # cnf_append "VBOX_PATH_QT3" "$q" - later/never?
1302 cnf_append "PATH_SDK_QT3" "$q"
1303 cnf_append "PATH_SDK_QT3_LIB" "$q/$l"
1304 cnf_append "PATH_SDK_QT3_INC" "$q/include"
1305 cnf_append "PATH_TOOL_QT3_BIN" "$q/bin"
1306 fi
1307 fi
1308}
1309
1310
1311#
1312# Check for the Qt4 library, needed by VirtualBox4
1313#
1314# Currently not fatal.
1315#
1316check_qt4()
1317{
1318 foundqt4=
1319 test_header Qt4
1320 if [ "$OS" = "darwin" ]; then
1321 if [ -f "/System/Library/Frameworks/QtCore.framework/QtCore" ]; then
1322 PATH_SDK_QT4="/System/Library/Framework/QtCore.framework"
1323 elif [ -f "/Library/Frameworks/QtCore.framework/QtCore" ]; then
1324 PATH_SDK_QT4="/Library/Frameworks/QtCore.framework"
1325 fi
1326 if [ -n "$PATH_SDK_QT4" ]; then
1327 foundqt4=1
1328 INCQT4="$PATH_SDK_QT4/Headers"
1329 LIBQT4=
1330 FLGQT4="-framework QtCore"
1331 else
1332 log_failure "Qt4 framework not found (can be disable using --disable-qt4)"
1333 fail
1334 fi
1335 else
1336 if [ $QT4DIR_PKGCONFIG -eq 1 ]; then
1337 # default is to use pkg-config
1338 if which_wrapper pkg-config > /dev/null; then
1339 # this braindead path is necessary for mdv2008.1
1340 qt4_ver=`\
1341 PKG_CONFIG_PATH=/usr/lib/qt4/lib/pkgconfig \
1342 pkg-config QtCore --modversion 2>> $LOG`
1343 if [ $? -ne 0 ]; then
1344 log_failure "not found"
1345 fail
1346 else
1347 FLGQT4=`\
1348 PKG_CONFIG_PATH=/usr/lib/qt4/lib/pkgconfig \
1349 pkg-config QtCore --cflags`
1350 INCQT4=`strip_I "$FLGQT4"`
1351 LIBQT4=`\
1352 PKG_CONFIG_PATH=/usr/lib/qt4/lib/pkgconfig \
1353 PKG_CONFIG_ALLOW_SYSTEM_LIBS=1 \
1354 pkg-config QtCore --libs`
1355 foundqt4=1
1356 fi
1357 else
1358 log_failure "pkg-config not found"
1359 fail
1360 fi
1361 else
1362 # do it the old way (e.g. user has specified QT4DIR)
1363 cat > .tmp_src.cc << EOF
1364#include <cstdio>
1365#include <QtGlobal>
1366extern "C" int main(void)
1367{
1368 printf("found version %s", QT_VERSION_STR);
1369#if QT_VERSION >= 0x040300
1370 printf(", OK.\n");
1371 return 0;
1372#else
1373 printf(", expected version 4.3.0 or higher\n");
1374 return 1;
1375#endif
1376}
1377EOF
1378 for q in $QT4DIR; do
1379 INCQT4="$q/include $q/include/QtCore"
1380 FLGQT4="-DQT_SHARED"
1381 I_INCQT4=`prefix_I "$INCQT4"`
1382 LIBQT4="-L$q/lib -lVBoxQtCore"
1383 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal; then
1384 foundqt4=2
1385 break;
1386 fi
1387 LIBQT4="-L$q/lib -lQtCore"
1388 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal; then
1389 foundqt4=1
1390 break;
1391 fi
1392 done
1393 fi
1394 fi
1395 if [ -n "$foundqt4" ]; then
1396 cat > .tmp_src.cc << EOF
1397#include <cstdio>
1398#include <QtGlobal>
1399extern "C" int main(void)
1400{
1401 printf("found version %s", QT_VERSION_STR);
1402#if QT_VERSION >= 0x040300
1403 printf(", OK.\n");
1404 return 0;
1405#else
1406 printf(", expected version 4.3.0 or higher\n");
1407 return 1;
1408#endif
1409}
1410EOF
1411 [ -n "$INCQT4" ] && I_INCQT4=`prefix_I "$INCQT4"`
1412 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal; then
1413 if test_execute_path "`strip_L "$LIBQT4"`"; then
1414 if [ "$OS" != "darwin" ]; then
1415 # strip .../QtCore as we add components ourself
1416 INCQT4=`echo "$INCQT4"|$KBUILD_SED 's|\([^ ]*\)/QtCore|\1|g; s| $||g'`
1417 # store only the first path, remove all other pathes
1418 # most likely pkg-config gave us -I/usr/include/qt4 -I/usr/include/qt4/QtCore
1419 INCQT4=`echo "$INCQT4"|$KBUILD_SED 's|\([^ ]*\) .*|\1|'`
1420 cnf_append "VBOX_PATH_QT4_LIB" "`strip_L "$LIBQT4"`"
1421 cnf_append "SDK_QT4_LIBPATH" "`strip_L "$LIBQT4"`"
1422 cnf_append "PATH_SDK_QT4_INC" "$INCQT4"
1423 # this is not quite right since the qt libpath does not have to be first...
1424 cnf_append "PATH_SDK_QT4_LIB" '$'"(firstword `strip_L "$LIBQT4"`)"
1425 if [ "$foundqt4" = "2" ]; then
1426 cnf_append "VBOX_WITH_QT4_SUN" "1"
1427 fi
1428 test_header "Qt4 devtools"
1429 for q in $QT4DIR; do
1430 if which_wrapper "$q/bin/moc" > /dev/null; then
1431 moc_ver=`$q/bin/moc -v 2>&1|sed 's+^.*(Qt \(.*\))+\1+'`
1432 if [ $? -ne 0 ]; then
1433 log_failure "not found"
1434 fail
1435 else
1436 log_success "found version $moc_ver"
1437 cnf_append "VBOX_PATH_QT4" "$q"
1438 cnf_append "PATH_SDK_QT4" "$q"
1439 cnf_append "PATH_TOOL_QT4" "$q"
1440 cnf_append "PATH_TOOL_QT4_BIN" "$q/bin"
1441 return
1442 fi
1443 fi
1444 done
1445 fi
1446 fi
1447 else
1448 log_failure "not found"
1449 fail
1450 fi
1451 else
1452 log_failure "not found"
1453 fail
1454 fi
1455}
1456
1457
1458#
1459# Check whether static libstdc++ is installed
1460#
1461check_staticlibstdcxx()
1462{
1463 test_header "static stc++ library"
1464 libstdcxx=`$CXX -print-file-name=libstdc++.a`
1465 cat > .tmp_src.cc << EOF
1466#include <string>
1467
1468extern "C" int main(void)
1469{
1470 std::string s = "test";
1471 return 0;
1472}
1473EOF
1474 if test_compile "$libstdcxx" libstdc++ libstdc++; then
1475 log_success "found"
1476 fi
1477}
1478
1479
1480#
1481# Check for Linux sources
1482#
1483check_linux()
1484{
1485 test_header "Linux kernel sources"
1486 cat > .tmp_src.c << EOF
1487#include <linux/version.h>
1488int printf(const char *format, ...);
1489int main(void)
1490{
1491 printf("found version %d.%d.%d", LINUX_VERSION_CODE / 65536,
1492 (LINUX_VERSION_CODE % 65536) / 256,
1493 LINUX_VERSION_CODE % 256);
1494#if LINUX_VERSION_CODE > KERNEL_VERSION(2,4,0)
1495 printf(", OK.\n");
1496 return 0;
1497#else
1498 printf(", expected version 2.4.0 or higher\n");
1499 return 1;
1500#endif
1501}
1502EOF
1503 echo "compiling the following source file:" >> $LOG
1504 cat .tmp_src.c >> $LOG
1505 echo "using the following command line:" >> $LOG
1506 echo "$CC -O -Wall -o .tmp_out .tmp_src.c -nostdinc -I$LINUX/include" >> $LOG
1507 $CC -O -Wall -o .tmp_out .tmp_src.c -nostdinc -I$LINUX/include >> $LOG 2>&1
1508 if [ $? -ne 0 ]; then
1509 echo
1510 echo " Linux kernel headers not found at $LINUX"
1511 echo " Check the file $LOG for detailed error information."
1512 fail
1513 else
1514 if test_execute; then
1515 cnf_append "VBOX_LINUX_SRC" "`cd $LINUX ; pwd`"
1516 fi
1517 fi
1518}
1519
1520
1521#
1522# Check for kchmviewer, needed to display the online help
1523# (unused as we ship kchmviewer)
1524#
1525check_kchmviewer()
1526{
1527 test_header kchmviewer
1528 if check_avail "$KCHMVIEWER" KCHMVIEWER; then
1529 kchmviewer_ver=`$KCHMVIEWER --version|grep "^KchmViewer:"|sed 's+^KchmViewer: \(.*\)+\1+'`
1530 if [ $? -ne 0 ]; then
1531 log_failure "not found"
1532 fail
1533 else
1534 log_success "found version $kchmviewer_ver"
1535 fi
1536 fi
1537}
1538
1539
1540#
1541# Check for the kBuild tools, we don't support GNU make
1542#
1543check_kbuild()
1544{
1545 test_header kBuild
1546 if which_wrapper "$KBUILDDIR/bin/$OS.$BUILD_MACHINE/kmk" > /dev/null; then
1547 KBUILDDIR_BIN="$KBUILDDIR/bin/$OS.$BUILD_MACHINE"
1548 echo "export PATH_KBUILD=\"`cd $KBUILDDIR ; pwd`\"" >> $ENV
1549 echo "export PATH_DEVTOOLS=\"$DEVDIR\"" >> $ENV
1550 echo "path_kbuild_bin=\"\$PATH_KBUILD/bin/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"" >> $ENV
1551 echo "export PATH_KBUILD_BIN=\"\$path_kbuild_bin\"" >> $ENV
1552 echo "path_dev_bin=\"\$PATH_DEVTOOLS/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"/bin" >> $ENV
1553 if [ "$OS" = "solaris" ]; then
1554 # Because of sh being non-default shell in Solaris we need to export PATH again when
1555 # sourcing env.sh. Simply exporting from ./configure does not export PATH correctly.
1556 echo "PATH=\"$ORGPATH\"" >> $ENV
1557 echo "echo \"\$PATH\" | /usr/sfw/bin/ggrep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1558 echo "echo \"\$PATH\" | /usr/sfw/bin/ggrep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1559 else
1560 echo "echo \"\$PATH\" | grep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1561 echo "echo \"\$PATH\" | grep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1562 fi
1563 echo "export PATH" >> $ENV
1564 echo "unset path_kbuild_bin path_dev_bin" >> $ENV
1565 KBUILD_SED="$KBUILDDIR_BIN/kmk_sed"
1566 elif check_avail "kmk" KBUILDDIR really; then
1567 # check for installed kBuild
1568 KBUILD_SED="`which_wrapper kmk_sed`"
1569 else
1570 fail
1571 fi
1572 log_success "found"
1573}
1574
1575
1576#
1577# Check for compiler.h
1578# Some Linux distributions include "compiler.h" in their libc linux
1579# headers package, some don't. Most don't need it, building might (!)
1580# not succeed on openSUSE without it.
1581#
1582# See http://www.mail-archive.com/qemu-devel%40nongnu.org/msg07980.html
1583#
1584check_compiler_h()
1585{
1586 test_header compiler.h
1587 if ! test -f "/usr/include/linux/compiler.h"; then
1588 cnf_append "VBOX_WITHOUT_LINUX_COMPILER_H" "1"
1589 log_success "compiler.h not found"
1590 else
1591 log_success "compiler.h found"
1592 fi
1593}
1594
1595
1596#
1597# Check if we are able to build 32-bit applications (needed for the guest additions)
1598#
1599check_32bit()
1600{
1601 test_header "32-bit support"
1602 cat > .tmp_src.c << EOF
1603#include <stdint.h>
1604int main(void)
1605{
1606 return 0;
1607}
1608EOF
1609 echo "compiling the following source file:" >> $LOG
1610 cat .tmp_src.c >> $LOG
1611 echo "using the following command line:" >> $LOG
1612 echo "$CC -m32 -O -Wall -o .tmp_out .tmp_src.c" >> $LOG
1613 $CC -m32 -O -Wall -o .tmp_out .tmp_src.c >> $LOG 2>&1
1614 if [ $? -ne 0 ]; then
1615 echo
1616 echo " Cannot compile 32-bit applications (missing headers and/or libraries)!"
1617 echo " Check the file $LOG for detailed error information."
1618 fail
1619 fi
1620 log_success ""
1621}
1622
1623
1624#
1625# Check for Python
1626#
1627check_python()
1628{
1629 test_header "python support"
1630 cat > .tmp_src.cc << EOF
1631#include <cstdio>
1632#include <Python.h>
1633extern "C" int main(void)
1634{
1635 Py_Initialize();
1636 printf("found version %s", PY_VERSION);
1637#if PY_VERSION_HEX >= 0x02030000
1638 printf(", OK.\n");
1639 return 0;
1640#else
1641 printf(", expected version 2.3 or higher\n");
1642 return 1;
1643#endif
1644}
1645EOF
1646 found=
1647 for p in $PYTHONDIR; do
1648 for d in python2.6 python2.5 python2.4 python2.3; do
1649 for b in lib64 lib/64 lib; do
1650 echo "compiling the following source file:" >> $LOG
1651 cat .tmp_src.cc >> $LOG
1652 echo "using the following command line:" >> $LOG
1653 echo "$CXX -O -Wall -o .tmp_out .tmp_src.cc -I$p/include/$d $p/$b/lib$d.so" >> $LOG
1654 $CXX -O -Wall -o .tmp_out .tmp_src.cc -I$p/include/$d $p/$b/lib$d.so >> $LOG 2>&1
1655 if [ $? -eq 0 ]; then
1656 found=1
1657 break
1658 fi
1659 done
1660 if [ -n "$found" ]; then break; fi
1661 done
1662 if [ -n "$found" ]; then break; fi
1663 done
1664 if [ -n "$found" ]; then
1665 if test_execute; then
1666 cnf_append "VBOX_WITH_PYTHON" "1"
1667 cnf_append "VBOX_PATH_PYTHON_INC" "$p/include/$d"
1668 cnf_append "VBOX_LIB_PYTHON" "$p/$b/lib$d.so"
1669 else
1670 log_failure "not found"
1671 fail
1672 fi
1673 else
1674 log_failure "not found"
1675 fail
1676 fi
1677}
1678
1679
1680#
1681# Setup wine
1682#
1683setup_wine()
1684{
1685 test_header "Wine support"
1686 if ! which_wrapper wine > /dev/null; then
1687 echo " wine binary not found"
1688 fail
1689 fi
1690 if ! which_wrapper wineprefixcreate > /dev/null; then
1691 echo " wineprefixcreate not found"
1692 fail
1693 fi
1694 export WINEPREFIX="${ODIR}wine.$BUILD_MACHINE"
1695 echo "export WINEPREFIX=\"${ODIR}wine.$BUILD_MACHINE\"" >> $ENV
1696 rm -rf $WINEPREFIX
1697 mkdir -p $WINEPREFIX
1698 touch $WINEPREFIX/.no_prelaunch_window_flag
1699 if ! wineprefixcreate -q > /dev/null 2>&1; then
1700 echo " wineprefixcreate failed"
1701 fail
1702 fi
1703 tmp=.tmp.wine.reg
1704 rm -f $tmp
1705 echo 'REGEDIT4' > $tmp
1706 echo '' >> $tmp
1707 echo '[HKEY_LOCAL_MACHINE\System\CurrentControlSet\Control\Session Manager\Environment]' >> $tmp
1708 echo "\"PATH\"=\"c:\\\\\\\\windows\\\\\\\\system32;c:\\\\\\\\windows;z:$DEVDIR/win.x86/vcc/v8/bin/Microsoft.VC80.CRT;z:$DEVDIR/win.x86/HTML_Help_Workshop/v1.3\"" >> $tmp
1709 echo '' >> $tmp
1710 echo '[HKEY_CURRENT_USER\Software\Wine\AppDefaults\hhc.exe\DllOverrides]' >> $tmp
1711 echo '"itss"="native"' >> $tmp
1712 echo '' >> $tmp
1713 echo '[HKEY_CURRENT_USER\Software\Wine\AppDefaults\hhw.exe\DllOverrides]' >> $tmp
1714 echo '"itss"="native"' >> $tmp
1715 echo '' >> $tmp
1716 if ! wine regedit $tmp > /dev/null 2>&1; then
1717 rm -f $tmp
1718 echo " failed to load registry changes (path)."
1719 fail
1720 fi
1721 rm -f $tmp
1722 log_success "found"
1723}
1724
1725
1726#
1727# Determines the Darwin version.
1728# @todo This should really check the Xcode/SDK version.
1729#
1730check_darwinversion()
1731{
1732 test_header "Darwin version"
1733 darwin_ver=`uname -r`
1734 case "$darwin_ver" in
1735 9\.*)
1736 darwin_ver="10.5"
1737 #cnf_append "VBOX_TARGET_MAC_OS_X_VERSION_10_5" "1"
1738 ;;
1739 8\.*)
1740 darwin_ver="10.4"
1741 ;;
1742 *)
1743 echo " failed to determin darwin version. (uname -r: $darwin_ver)"
1744 fail
1745 darwin_ver="unknown"
1746 ;;
1747 esac
1748 log_success "found version $darwin_ver"
1749}
1750
1751
1752#
1753# Checks that i386-elf-gcc-3.4.6, i386-elf-gcc-3.4.3, i386-elf-gcc-3.4 or i386-elf-gcc
1754# is around to prevent confusion when the build fails in src/recompiler.
1755# Note. Keep the which order in sync with the $(which ) in src/recompiler/Makefile.kmk.
1756#
1757check_i386elfgcc()
1758{
1759 test_header "i386-elf-gcc"
1760 i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4.6`
1761 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4.3`
1762 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4`
1763 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc`
1764 if test -z "$i386_elf_gcc"; then
1765 echo " failed to find i386-elf-gcc"
1766 fail
1767 fi
1768 log_success "found $i386_elf_gcc"
1769}
1770
1771
1772#
1773# Show help
1774#
1775show_help()
1776{
1777 cat << EOF
1778Usage: ./configure [OPTIONS]...
1779
1780Configuration:
1781 -h, --help display this help and exit
1782 --nofatal don't abort on errors
1783 --disable-xpcom disable XPCOM and related stuff
1784 --disable-python disable python bindings
1785 --disable-sdl-ttf disable SDL_ttf detection
1786 --disable-alsa disable the ALSA sound backend
1787 --disable-pulse disable the PulseAudio backend
1788 --disable-libhal don't use hal for hardware detection
1789 --disable-kmods don't build Linux kernel modules (host and guest)
1790 --disable-hardening don't be strict about /dev/vboxdrv access
1791 --build-libxml2 build libxml2 from sources
1792 --build-libxslt build libxslt from sources
1793 --setup-wine setup a Wine directory and register the hhc hack
1794
1795Paths:
1796 --with-gcc=PATH location of the gcc compiler [$CC]
1797 --with-g++=PATH location of the g++ compiler [$CXX]
1798 --with-gcc-compat=PATH location of the gcc compiler for recompiler [$CC]
1799 --with-kbuild=DIR kbuild directory [$KBUILDDIR]
1800 --with-iasl=PATH location of the iasl compiler [$IASL]
1801 --with-linux=DIR Linux kernel source directory [$LINUX]
1802 --with-mkisofs=PATH location of mkisofs [$MKISOFS]
1803 --with-qt-dir=DIR directory for Qt3 headers/libraries [$QT3DIR]
1804 --with-qt4-dir=DIR directory for Qt4 headers/libraries [pkgconfig]
1805
1806Build type:
1807 -d, --build-debug build with debugging symbols and assertions
1808 --build-profile build with profiling support
1809 --build-headless build headless (without any X11 frontend)
1810EOF
1811 exit 0
1812}
1813
1814
1815#
1816# The body.
1817#
1818
1819# scan command line options
1820for option in $*; do
1821 case "$option" in
1822 --help|-help|-h)
1823 show_help
1824 ;;
1825 --nofatal)
1826 nofatal=1
1827 ;;
1828 --env-only)
1829 ENV_ONLY=1
1830 ;;
1831 --with-gcc=*)
1832 CC=`echo $option | cut -d'=' -f2`
1833 ;;
1834 --with-g++=*)
1835 CXX=`echo $option | cut -d'=' -f2`
1836 ;;
1837 --with-gcc-compat=*)
1838 CC_COMPAT=`echo $option | cut -d'=' -f2`
1839 ;;
1840 --with-kbuild=*)
1841 KBUILDDIR=`echo $option | cut -d'=' -f2`
1842 if echo $KBUILDDIR|grep -q "$INVALID_CHARS"; then
1843 echo "Error: KBUILDDIR contains invalid characters!"
1844 exit 1
1845 fi
1846 ;;
1847 --with-qt-dir=*)
1848 QT3DIR=`echo $option | cut -d'=' -f2`
1849 ;;
1850 --with-qt4-dir=*)
1851 QT4DIR=`echo $option | cut -d'=' -f2`
1852 QT4DIR_PKGCONFIG=0
1853 ;;
1854 --with-iasl=*)
1855 IASL=`echo $option | cut -d'=' -f2`
1856 ;;
1857 --with-linux=*)
1858 LINUX=`echo $option | cut -d'=' -f2`
1859 ;;
1860 --with-mkisofs=*)
1861 MKISOFS=`echo $option | cut -d'=' -f2`
1862 ;;
1863 --disable-xpcom)
1864 WITH_XPCOM=0
1865 ;;
1866 --disable-python)
1867 WITH_PYTHON=0
1868 ;;
1869 --disable-sdl-ttf)
1870 WITH_SDL_TTF=0
1871 ;;
1872 --disable-qt)
1873 WITH_QT3=0
1874 WITH_QT4=0
1875 ;;
1876 --disable-qt3)
1877 WITH_QT3=0
1878 ;;
1879 --disable-qt4)
1880 WITH_QT4=0
1881 ;;
1882 --disable-alsa)
1883 WITH_ALSA=0
1884 ;;
1885 --disable-pulse)
1886 WITH_PULSE=0
1887 ;;
1888 --disable-libhal)
1889 WITH_LIBHAL=0
1890 ;;
1891 --disable-kmods)
1892 WITH_KMODS=0
1893 ;;
1894 --disable-hardening)
1895 WITH_HARDENING=0
1896 ;;
1897 --enable-hardening)
1898 WITH_HARDENING=2
1899 ;;
1900 --build-debug|-d)
1901 BUILD_TYPE=debug
1902 ;;
1903 --build-profile)
1904 BUILD_TYPE=profile
1905 ;;
1906 --build-libxml2)
1907 BUILD_LIBXML2=1
1908 ;;
1909 --build-libxslt)
1910 BUILD_LIBXSLT=1
1911 ;;
1912 --build-headless)
1913 HEADLESS=1
1914 WITH_SDL=0
1915 WITH_SDL_TTF=0
1916 WITH_X11=0
1917 WITH_QT3=0
1918 WITH_QT4=0
1919 ;;
1920 --ose)
1921 OSE=2
1922 ;;
1923 --odir=*)
1924 ODIR="`echo $option | cut -d'=' -f2`/"
1925 ;;
1926 --setup-wine)
1927 SETUP_WINE=1
1928 ;;
1929 *)
1930 echo
1931 echo "Unrecognized option \"$option\""
1932 echo
1933 show_help
1934 ;;
1935 esac
1936done
1937
1938LOG="$ODIR$LOG"
1939ENV="$ODIR$ENV"
1940CNF="$ODIR$CNF"
1941
1942# initialize output files
1943cat > $LOG << EOF
1944# Log file generated by
1945#
1946# '$0 $*'
1947#
1948
1949EOF
1950cat > $CNF << EOF
1951# -*- Makefile -*-
1952#
1953# automatically generated by
1954#
1955# '$0 $*'
1956#
1957# It will be completely overwritten if configure is executed again.
1958#
1959
1960EOF
1961cat > $ENV << EOF
1962#!/bin/bash
1963#
1964# automatically generated by
1965#
1966# '$0 $*'
1967#
1968# It will be completely overwritten if configure is executed again.
1969# Make sure you source this file once before you start to build VBox.
1970#
1971
1972EOF
1973
1974# test if we are OSE
1975if [ $OSE -eq 1 -a -d "`cd \`dirname $0\`; pwd`/src/VBox/Devices/USB" ]; then
1976 echo "Found USB devices, assuming VBOX_OSE = FALSE" >> $LOG
1977 echo >> $LOG
1978 OSE=0
1979fi
1980
1981if [ "$BUILD_TYPE" = "debug" ]; then
1982 echo "Creating DEBUG build!" >> $LOG
1983elif [ "$BUILD_TYPE" = "profile" ]; then
1984 echo "Creating PROFILE build!" >> $LOG
1985fi
1986
1987# first determine our environment
1988check_environment
1989check_kbuild
1990
1991[ -n "$ENV_ONLY" ] && exit 0
1992
1993# append the tools directory to the default search path
1994echo "$PATH" | grep -q "$DEVDIR_BIN" || PATH="$PATH:$DEVDIR_BIN"
1995export PATH
1996
1997# some things are not available in for OSE
1998if [ $OSE -ge 1 ]; then
1999 cnf_append "VBOX_OSE" "1"
2000 cnf_append "VBOX_WITH_TESTSUITE" ""
2001 cnf_append "VBOX_WITH_WIN32_ADDITIONS" ""
2002
2003 if [ "$OS" = "linux" ]; then
2004 cnf_append "VBOX_WITH_LINUX_ADDITIONS" "1"
2005 else
2006 cnf_append "VBOX_WITH_LINUX_ADDITIONS" ""
2007 fi
2008 echo >> $CNF
2009fi
2010
2011# headless
2012if [ -n "$HEADLESS" ]; then
2013 cnf_append "VBOX_HEADLESS" "1"
2014fi
2015
2016if [ "$OS" = "darwin" ]; then
2017 # On Darwin we want to build against Qt4 only. WITH_QT4 is enabled by
2018 # default so disable Qt3. --disable-qt disables both Qt3 and Qt4 GUI now,
2019 # --disable-qt4 disables only the Qt4 GUI (which is not appropriate for
2020 # Darwin as we disable the Qt3 here anyway.
2021 # (Qt3 builds for Intel Macs are usually not threaded or for X11. And they
2022 # don't contain our patches, which means the result isn't really usable.)
2023 WITH_QT3=0
2024 BUILD_LIBXSLT=1
2025 BUILD_LIBXML2=1
2026fi
2027
2028# emit disable directives corresponding to any --disable-xxx options.
2029[ $WITH_XPCOM -eq 0 ] && cnf_append "VBOX_WITH_MAIN" ""
2030[ $WITH_QT3 -eq 0 ] && cnf_append "VBOX_WITH_QTGUI" ""
2031[ $WITH_QT4 -eq 0 ] && cnf_append "VBOX_WITH_QT4GUI" ""
2032[ $WITH_SDL_TTF -eq 0 ] && cnf_append "VBOX_WITH_SECURELABEL" ""
2033[ $WITH_HARDENING -eq 0 ] && cnf_append "VBOX_WITHOUT_HARDENING" "1"
2034[ $WITH_HARDENING -eq 2 ] && cnf_append "VBOX_WITH_HARDENING" "2"
2035
2036# the tools
2037check_gcc
2038[ "$OS" != "darwin" ] && check_as86
2039[ "$OS" != "darwin" ] && check_bcc
2040[ "$OS" != "darwin" ] && check_iasl
2041# don't check for yasm for the time beeing as 0.40 and 0.50 both have known bugs
2042# [ "$OS" != "darwin" ] && check_yasm
2043[ "$OS" != "darwin" ] && check_xsltproc
2044[ $OSE -eq 0 -a "$OS" != "darwin" ] && check_mkisofs
2045
2046# the libraries
2047[ "$OS" != "darwin" ] && check_pthread
2048[ $WITH_XPCOM -eq 1 ] && check_libxml2
2049[ $WITH_XPCOM -eq 1 ] && check_libxslt
2050[ $WITH_LIBIDL -eq 1 ] && check_libidl
2051# build openssl on Darwin in every case
2052[ "$OS" != "darwin" -a $OSE -eq 0 ] && check_ssl
2053[ "$OS" != "darwin" ] && check_z
2054[ "$OS" != "darwin" ] && check_png
2055[ $OSE -eq 0 -a "$OS" = "linux" ] && check_pam
2056[ $WITH_SDL -eq 1 ] && check_sdl
2057[ $WITH_SDL_TTF -eq 1 -a $OSE -eq 0 ] && check_sdl_ttf
2058[ $WITH_X11 -eq 1 ] && check_x
2059# TODO check for Xmu (X11/Xmu/StdCmap.h)
2060# TODO check for mesa-common-dev (GL/glx.h)
2061# TODO check for libglu1-mesa-dev (GL/glu.h)
2062[ $WITH_X11 -eq 1 ] && check_xcursor
2063[ $WITH_QT3 -eq 1 ] && check_qt3
2064[ $WITH_QT4 -eq 1 ] && check_qt4
2065[ $WITH_PYTHON -eq 1 -a "$OS" != "darwin" ] && check_python
2066
2067# Linux-specific
2068if [ "$OS" = "linux" ]; then
2069 check_staticlibstdcxx
2070 if [ $WITH_KMODS -eq 1 ]; then
2071 check_linux
2072 else
2073 cnf_append "VBOX_LINUX_SRC" ""
2074 cnf_append "VBOX_WITH_VBOXDRV" ""
2075 cnf_append "VBOX_WITH_ADDITION_DRIVERS" ""
2076 fi
2077 if [ $WITH_ALSA -eq 1 ]; then
2078 check_alsa
2079 else
2080 cnf_append "VBOX_WITH_ALSA" ""
2081 fi
2082 if [ $WITH_PULSE -eq 1 ]; then
2083 check_pulse
2084 else
2085 cnf_append "VBOX_WITH_PULSE" ""
2086 fi
2087 if [ $WITH_LIBHAL -eq 1 ]; then
2088 check_libhal
2089 else
2090 cnf_append "VBOX_WITH_LIBHAL" ""
2091 fi
2092 check_compiler_h
2093 [ "$BUILD_MACHINE" = "amd64" ] && check_32bit
2094fi
2095
2096[ -n "$SETUP_WINE" ] && setup_wine
2097
2098# Darwin-specific
2099if [ "$OS" = "darwin" ]; then
2100 check_darwinversion
2101 check_i386elfgcc
2102fi
2103
2104# success!
2105echo
2106echo "Successfully generated '$CNF' and '$ENV'."
2107echo "Source '$ENV' once before you start to build VBox:"
2108echo ""
2109echo " source $ENV"
2110echo " kmk"
2111echo ""
2112if [ "$OS" = "linux" ]; then
2113 echo "To compile the kernel module, do:"
2114 echo ""
2115 echo " cd ./out/$OS.$TARGET_MACHINE/$BUILD_TYPE/bin/src/vboxdrv"
2116 echo " make"
2117 echo ""
2118fi
2119if [ $WITH_HARDENING -gt 0 ]; then
2120 echo ""
2121 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2122 echo " Hardening is enabled which means that the VBox binaries will not run from"
2123 echo " the binary directory. The binaries have to be installed suid root and some"
2124 echo " more prerequisites have to be fulfilled which is normally done by installing"
2125 echo " the final package. For development, the hardening feature can be disabled"
2126 echo " by specifying the --disable-hardening parameter. Please never disable that"
2127 echo " feature for the final distribution!"
2128 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2129 echo ""
2130else
2131 echo ""
2132 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2133 echo " Hardening is disabled. Please do NOT build packages for distribution with"
2134 echo " disabled hardening!"
2135 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2136 echo ""
2137fi
2138echo "Enjoy!"
2139cleanup
Note: See TracBrowser for help on using the repository browser.

© 2024 Oracle Support Privacy / Do Not Sell My Info Terms of Use Trademark Policy Automated Access Etiquette